Index: trunk/src/VBox/Additions/x11/vboxmouse/undefined_15
===================================================================
--- trunk/src/VBox/Additions/x11/vboxmouse/undefined_15	(revision 31252)
+++ trunk/src/VBox/Additions/x11/vboxmouse/undefined_15	(revision 31295)
@@ -1,103 +1,105 @@
-chdir
-xf86PostMotionEvent
-memset
-xf86AddEnabledDevice
-close
-ioctl
-memchr
-utimes
-__gmon_start__
-_Jv_RegisterClasses
-xf86AddInputDriver
-read
-strncmp
-malloc
-xf86RemoveEnabledDevice
-unlink
-__fxstat64
-iconv_open
-geteuid
-xf86ProcessCommonOptions
-free
-strlen
-xf86CheckStrOption
-__cxa_finalize
-xf86DeleteInput
-realpath
-InitButtonClassDeviceStruct
-fsync
-iconv
-futimes
-open64
-strstr
-fputs
-ftruncate64
-xf86SetIntOption
-fchmod
-memcpy
-putenv
-memmove
-strchr
-setenv
-getenv
-xf86InitValuatorAxisStruct
-__errno_location
-xf86CollectInputOptions
-__stack_chk_fail
-strcmp
-tolower
-getcwd
-strcpy
-miPointerGetScreen
-memcmp
-xf86MotionHistoryAllocate
-calloc
-__xstat64
-lseek64
-unsetenv
-xf86AllocateInput
-stderr
-xf86Msg
-xf86InitValuatorDefaults
-realloc
-getpwuid_r
-InitValuatorClassDeviceStruct
-fprintf
-write
-fcntl
-iconv_close
-rename
 GetMotionHistory
 GetMotionHistorySize
-fflush
-nl_langinfo
-lseek
-open
+InitButtonClassDeviceStruct
+InitPointerDeviceStruct
+InitPtrFeedbackClassDeviceStruct
+InitValuatorClassDeviceStruct
+_Jv_RegisterClasses
+___errno
+__cxa_finalize
+__deregister_frame_info_bases
+__divdi3
+__errno_location
+__fxstat64
+__gmon_start__
+__iob
+__moddi3
 __register_frame_info_bases
-__deregister_frame_info_bases
-stat
-fstat
-___errno
-ftruncate
-strpbrk
-__iob
+__stack_chk_fail
 __udivdi3
 __umoddi3
-__divdi3
-__moddi3
-InitPtrFeedbackClassDeviceStruct
-xf86ScaleAxis
+__xstat64
+calloc
+chdir
+chown
+close
+fchmod
+fcntl
+fflush
+flock
+fprintf
+fputs
+free
+fstat
+fsync
+ftruncate
+ftruncate64
+futimes
+getcwd
+getenv
+geteuid
+getpwuid_r
+iconv
+iconv_close
+iconv_open
+ioctl
+lchown
+lseek
+lseek64
+malloc
+memalign
+memchr
+memcmp
+memcpy
+memmove
+memset
+miPointerCurrentScreen
+miPointerGetMotionBufferSize
 miPointerGetMotionEvents
-miPointerGetMotionBufferSize
-miPointerCurrentScreen
+miPointerGetScreen
+mmap64
+mprotect
+munmap
+nl_langinfo
+open
+open64
+posix_memalign
+pthread_sigmask
+putenv
+read
+realloc
+realpath
+rename
 screenInfo
-InitPointerDeviceStruct
-flock
+setenv
 sigdelset
 sigfillset
-pthread_sigmask
-mprotect
-mmap64
-memalign
-posix_memalign
-munmap
+stat
+stderr
+strchr
+strcmp
+strcpy
+strlen
+strncmp
+strpbrk
+strstr
+tolower
+unlink
+unsetenv
+utimes
+write
+xf86AddEnabledDevice
+xf86AddInputDriver
+xf86AllocateInput
+xf86CheckStrOption
+xf86CollectInputOptions
+xf86DeleteInput
+xf86InitValuatorAxisStruct
+xf86InitValuatorDefaults
+xf86MotionHistoryAllocate
+xf86Msg
+xf86PostMotionEvent
+xf86ProcessCommonOptions
+xf86RemoveEnabledDevice
+xf86ScaleAxis
+xf86SetIntOption
Index: trunk/src/VBox/Additions/x11/vboxmouse/undefined_68
===================================================================
--- trunk/src/VBox/Additions/x11/vboxmouse/undefined_68	(revision 31252)
+++ trunk/src/VBox/Additions/x11/vboxmouse/undefined_68	(revision 31295)
@@ -1,75 +1,75 @@
+AdjustWaitForDelay
+ErrorF
+GetTimeInMillis
+InitPointerDeviceStruct
+RegisterBlockAndWakeupHandlers
+RemoveBlockAndWakeupHandlers
+Xcalloc
+Xfree
+XisbBlockDuration
+XisbFree
+XisbNew
+XisbRead
+Xstrdup
+__stack_chk_fail
+flock
+miPointerGetMotionBufferSize
+miPointerGetMotionEvents
+pthread_sigmask
+screenInfo
+sigdelset
+sigfillset
+xf86AddEnabledDevice
+xf86AddInputDriver
+xf86AddModuleInfo
+xf86AllocateInput
+xf86BlockSIGIO
+xf86CloseSerial
+xf86CollectInputOptions
+xf86ErrorF
+xf86FlushInput
+xf86GetAllowMouseOpenFail
 xf86GetMotionEvents
-xf86ReadSerial
-xf86FlushInput
-xf86WaitForInput
+xf86GetOS
+xf86GetSerialModemState
+xf86InitValuatorAxisStruct
+xf86InitValuatorDefaults
 xf86LoaderCheckSymbol
+xf86MotionHistoryAllocate
+xf86Msg
+xf86MsgVerb
+xf86NameCmp
+xf86OSMouseInit
+xf86OpenSerial
 xf86OptionListCreate
-AdjustWaitForDelay
-xf86GetSerialModemState
-xf86free
-xf86usleep
-xf86AddInputDriver
-xf86UnblockSIGIO
-xf86SetSerial
-xf86ReplaceIntOption
-xf86InitValuatorDefaults
-xf86open
-XisbFree
-xf86AddModuleInfo
-Xfree
-xf86ErrorF
-GetTimeInMillis
-xf86ProcessCommonOptions
-xf86AllocateInput
-xf86GetAllowMouseOpenFail
-xf86GetOS
-xf86AddEnabledDevice
-xf86malloc
-xf86strerror
-xf86ffs
-__stack_chk_fail
 xf86OptionListMerge
 xf86PostButtonEvent
-XisbBlockDuration
-xf86MotionHistoryAllocate
-xf86MsgVerb
-xf86CollectInputOptions
-RegisterBlockAndWakeupHandlers
+xf86PostMotionEvent
+xf86ProcessCommonOptions
+xf86ReadSerial
+xf86RemoveEnabledDevice
+xf86ReplaceIntOption
+xf86SerialModemSetBits
+xf86SetBoolOption
+xf86SetIntOption
+xf86SetSerial
+xf86SetSerialModemState
+xf86SetSerialSpeed
+xf86SetStrOption
+xf86UnblockSIGIO
+xf86WaitForInput
+xf86WriteSerial
+xf86abs
+xf86close
+xf86errno
+xf86ffs
+xf86free
+xf86ioctl
+xf86malloc
+xf86memcpy
+xf86open
 xf86sprintf
-xf86SerialModemSetBits
-xf86Msg
-XisbNew
-xf86OSMouseInit
-xf86close
-xf86ioctl
-xf86SetSerialModemState
-XisbRead
-Xcalloc
-xf86CloseSerial
-xf86BlockSIGIO
-ErrorF
+xf86sscanf
+xf86strerror
 xf86strncmp
-xf86RemoveEnabledDevice
-xf86NameCmp
-xf86InitValuatorAxisStruct
-InitPointerDeviceStruct
-RemoveBlockAndWakeupHandlers
-xf86memcpy
-xf86SetIntOption
-Xstrdup
-miPointerGetMotionBufferSize
-xf86OpenSerial
-screenInfo
-xf86abs
-miPointerGetMotionEvents
-xf86sscanf
-xf86SetBoolOption
-xf86PostMotionEvent
-xf86SetSerialSpeed
-xf86WriteSerial
-xf86errno
-xf86SetStrOption
-flock
-sigdelset
-sigfillset
-pthread_sigmask
+xf86usleep
Index: trunk/src/VBox/Additions/x11/vboxmouse/undefined_70
===================================================================
--- trunk/src/VBox/Additions/x11/vboxmouse/undefined_70	(revision 31252)
+++ trunk/src/VBox/Additions/x11/vboxmouse/undefined_70	(revision 31295)
@@ -1,154 +1,156 @@
-xf86ReadSerial
-xf86sscanf
+AdjustWaitForDelay
+ErrorF
+GetTimeInMillis
+InitPointerDeviceStruct
+RegisterBlockAndWakeupHandlers
+RemoveBlockAndWakeupHandlers
+XNFalloc
+XNFrealloc
+Xalloc
+Xcalloc
+Xfree
+XisbBlockDuration
+XisbFree
+XisbNew
+XisbRead
 Xstrdup
+_Jv_RegisterClasses
+___errno
+__cxa_finalize
+__deregister_frame_info_bases
+__divdi3
+__errno_location
+__fxstat64
+__gmon_start__
+__iob
+__moddi3
+__register_frame_info_bases
+__stack_chk_fail
+__udivdi3
+__umoddi3
+__xstat64
+calloc
 chdir
-RegisterBlockAndWakeupHandlers
-xf86ReplaceIntOption
-XisbRead
-xf86PostMotionEvent
-xf86WaitForInput
+chown
+close
+currentTime
+fchmod
+fcntl
+fflush
+flock
+fprintf
+fputs
+free
+fstat
+fsync
+ftruncate
+ftruncate64
+futimes
+getcwd
+getenv
+geteuid
+getpwuid_r
+iconv
+iconv_close
+iconv_open
+ioctl
+lchown
+lseek
+lseek64
+malloc
+memalign
+memchr
+memcmp
+memcpy
+memmove
 memset
-xf86AddEnabledDevice
-close
-xf86strtol
-ioctl
-memchr
-xf86UnblockSIGIO
-utimes
-xf86sprintf
-XisbFree
-__gmon_start__
-_Jv_RegisterClasses
-xf86AddInputDriver
-ErrorF
-Xalloc
-xf86FindOptionValue
+miPointerGetMotionBufferSize
+miPointerGetMotionEvents
+mmap64
+mprotect
+munmap
+nl_langinfo
+open
+open64
+posix_memalign
+pthread_sigmask
+putenv
 read
-strncmp
-malloc
-xf86RemoveEnabledDevice
-unlink
-xf86sin
-xf86GetMotionEvents
-AdjustWaitForDelay
-xf86PostButtonEvent
-xf86FlushInput
-__fxstat64
-iconv_open
-xf86cos
-geteuid
-xf86errno
-currentTime
-xf86NameCmp
-xf86ProcessCommonOptions
-xf86OptionListMerge
-free
-strlen
-xf86CheckStrOption
-xf86OptionListCreate
-__cxa_finalize
-xf86OSMouseInit
-miPointerGetMotionEvents
+realloc
 realpath
-miPointerGetMotionBufferSize
-xf86usleep
-fsync
-iconv
-futimes
-open64
-strstr
-xf86OpenSerial
-RemoveBlockAndWakeupHandlers
-fputs
-Xcalloc
-ftruncate64
-xf86SetIntOption
-xf86GetAllowMouseOpenFail
-xf86SetStrOption
-Xfree
-fchmod
-memcpy
-putenv
-xf86SetBoolOption
-GetTimeInMillis
-memmove
-strchr
+rename
+screenInfo
 setenv
-getenv
-xf86ffs
-xf86SerialModemSetBits
-xf86InitValuatorAxisStruct
-__errno_location
-xf86CollectInputOptions
-xf86LoaderCheckSymbol
-__stack_chk_fail
-XisbNew
-strcmp
-tolower
-xf86GetSerialModemState
-getcwd
-xf86SetSerial
-InitPointerDeviceStruct
-xf86SetSerialModemState
-strcpy
-xf86strerror
-xf86MsgVerb
-xf86memcpy
-memcmp
-xf86MotionHistoryAllocate
-calloc
-XNFalloc
-__xstat64
-xf86GetOS
-xf86MarkOptionUsedByName
-xf86ErrorF
-lseek64
-xf86strncmp
-xf86GetBuiltinInterfaceVersion
-unsetenv
-xf86AllocateInput
-stderr
-xf86Msg
-xf86CloseSerial
-xf86InitValuatorDefaults
-realloc
-getpwuid_r
-xf86WriteSerial
-fprintf
-xf86OptionListFree
-write
-xf86AddModuleInfo
-XNFrealloc
-xf86BlockSIGIO
-XisbBlockDuration
-fcntl
-screenInfo
-iconv_close
-rename
-xf86SetSerialSpeed
-fflush
-xf86abs
-open
-fstat
-___errno
-ftruncate
-nl_langinfo
-__deregister_frame_info_bases
-__register_frame_info_bases
-lseek
-stat
-strpbrk
-__iob
-__divdi3
-__umoddi3
-__udivdi3
-__moddi3
-flock
 sigdelset
 sigfillset
-pthread_sigmask
-mprotect
-mmap64
-memalign
-posix_memalign
-munmap
+stat
+stderr
+strchr
+strcmp
+strcpy
+strlen
+strncmp
+strpbrk
+strstr
+tolower
+unlink
+unsetenv
+utimes
+write
+xf86AddEnabledDevice
+xf86AddInputDriver
+xf86AddModuleInfo
+xf86AllocateInput
+xf86BlockSIGIO
+xf86CheckStrOption
+xf86CloseSerial
+xf86CollectInputOptions
+xf86ErrorF
+xf86FindOptionValue
+xf86FlushInput
+xf86GetAllowMouseOpenFail
+xf86GetBuiltinInterfaceVersion
+xf86GetMotionEvents
+xf86GetOS
+xf86GetSerialModemState
+xf86InitValuatorAxisStruct
+xf86InitValuatorDefaults
+xf86LoaderCheckSymbol
+xf86MarkOptionUsedByName
+xf86MotionHistoryAllocate
+xf86Msg
+xf86MsgVerb
+xf86NameCmp
+xf86OSMouseInit
+xf86OpenSerial
+xf86OptionListCreate
+xf86OptionListFree
+xf86OptionListMerge
+xf86PostButtonEvent
+xf86PostMotionEvent
+xf86ProcessCommonOptions
+xf86ReadSerial
+xf86RemoveEnabledDevice
+xf86ReplaceIntOption
+xf86SerialModemSetBits
+xf86SetBoolOption
+xf86SetIntOption
+xf86SetSerial
+xf86SetSerialModemState
+xf86SetSerialSpeed
+xf86SetStrOption
+xf86UnblockSIGIO
+xf86WaitForInput
+xf86WriteSerial
+xf86abs
+xf86cos
+xf86errno
+xf86ffs
+xf86memcpy
+xf86sin
+xf86sprintf
+xf86sscanf
+xf86strerror
+xf86strncmp
+xf86strtol
+xf86usleep
Index: trunk/src/VBox/Additions/x11/vboxmouse/undefined_71
===================================================================
--- trunk/src/VBox/Additions/x11/vboxmouse/undefined_71	(revision 31252)
+++ trunk/src/VBox/Additions/x11/vboxmouse/undefined_71	(revision 31295)
@@ -1,152 +1,154 @@
-xf86ReadSerial
+AdjustWaitForDelay
+ErrorF
+GetTimeInMillis
+InitPointerDeviceStruct
+RegisterBlockAndWakeupHandlers
+RemoveBlockAndWakeupHandlers
+XNFalloc
+XNFrealloc
+Xalloc
+Xcalloc
+Xfree
+XisbBlockDuration
+XisbFree
+XisbNew
+XisbRead
 Xstrdup
+_Jv_RegisterClasses
+___errno
+__cxa_finalize
+__deregister_frame_info_bases
+__divdi3
+__errno_location
+__fxstat64
+__gmon_start__
+__iob
+__moddi3
+__register_frame_info_bases
+__stack_chk_fail
+__udivdi3
+__umoddi3
+__xstat64
+abs
+calloc
 chdir
-RegisterBlockAndWakeupHandlers
-xf86ReplaceIntOption
-XisbRead
-xf86PostMotionEvent
-xf86WaitForInput
+chown
+close
+cos
+currentTime
+fchmod
+fcntl
+fflush
+ffs
+flock
+fprintf
+fputs
+free
+fstat
+fsync
+ftruncate
+ftruncate64
+futimes
+getcwd
+getenv
+geteuid
+getpwuid_r
+iconv
+iconv_close
+iconv_open
+ioctl
+lchown
+lseek
+lseek64
+malloc
+memalign
+memchr
+memcmp
+memcpy
+memmove
 memset
-xf86AddEnabledDevice
-close
-ioctl
-memchr
-xf86UnblockSIGIO
-utimes
-XisbFree
-__gmon_start__
-_Jv_RegisterClasses
-xf86AddInputDriver
-ErrorF
-Xalloc
-xf86FindOptionValue
+miPointerGetMotionBufferSize
+miPointerGetMotionEvents
+mmap64
+mprotect
+munmap
+nl_langinfo
+open
+open64
+posix_memalign
+pthread_sigmask
+putenv
 read
-strncmp
-malloc
-xf86RemoveEnabledDevice
-unlink
-xf86GetMotionEvents
-AdjustWaitForDelay
-xf86PostButtonEvent
-xf86FlushInput
-__fxstat64
-iconv_open
-geteuid
-xf86errno
-currentTime
-xf86NameCmp
-xf86ProcessCommonOptions
-xf86OptionListMerge
-free
-strlen
-xf86CheckStrOption
-xf86OptionListCreate
-__cxa_finalize
-xf86OSMouseInit
-miPointerGetMotionEvents
+realloc
 realpath
-miPointerGetMotionBufferSize
+rename
+screenInfo
+setenv
+sigdelset
+sigfillset
+sin
 sprintf
 sscanf
-fsync
-iconv
-futimes
+stat
+stderr
+strchr
+strcmp
+strcpy
+strlen
+strncmp
+strpbrk
+strstr
+strtol
+tolower
+unlink
+unsetenv
 usleep
-open64
-strstr
+utimes
+write
+xf86AddEnabledDevice
+xf86AddInputDriver
+xf86AddModuleInfo
+xf86AllocateInput
+xf86BlockSIGIO
+xf86CheckStrOption
+xf86CloseSerial
+xf86CollectInputOptions
+xf86ErrorF
+xf86FindOptionValue
+xf86FlushInput
+xf86GetAllowMouseOpenFail
+xf86GetBuiltinInterfaceVersion
+xf86GetMotionEvents
+xf86GetOS
+xf86GetSerialModemState
+xf86InitValuatorAxisStruct
+xf86InitValuatorDefaults
+xf86LoaderCheckSymbol
+xf86MarkOptionUsedByName
+xf86MotionHistoryAllocate
+xf86Msg
+xf86MsgVerb
+xf86NameCmp
+xf86OSMouseInit
 xf86OpenSerial
-RemoveBlockAndWakeupHandlers
-fputs
-strtol
-Xcalloc
-ftruncate64
+xf86OptionListCreate
+xf86OptionListFree
+xf86OptionListMerge
+xf86PostButtonEvent
+xf86PostMotionEvent
+xf86ProcessCommonOptions
+xf86ReadSerial
+xf86RemoveEnabledDevice
+xf86ReplaceIntOption
+xf86SerialModemSetBits
+xf86SetBoolOption
 xf86SetIntOption
-xf86GetAllowMouseOpenFail
+xf86SetSerial
+xf86SetSerialModemState
+xf86SetSerialSpeed
 xf86SetStrOption
-Xfree
-fchmod
-memcpy
-putenv
-ffs
-xf86SetBoolOption
-GetTimeInMillis
-memmove
-strchr
-setenv
-getenv
-xf86SerialModemSetBits
-xf86InitValuatorAxisStruct
-__errno_location
-xf86CollectInputOptions
-xf86LoaderCheckSymbol
-__stack_chk_fail
-XisbNew
-strcmp
-tolower
-xf86GetSerialModemState
-getcwd
-xf86SetSerial
-InitPointerDeviceStruct
-xf86SetSerialModemState
-strcpy
+xf86UnblockSIGIO
+xf86WaitForInput
+xf86WriteSerial
+xf86errno
 xf86strerror
-xf86MsgVerb
-sin
-memcmp
-xf86MotionHistoryAllocate
-calloc
-XNFalloc
-__xstat64
-xf86GetOS
-xf86MarkOptionUsedByName
-xf86ErrorF
-lseek64
-xf86GetBuiltinInterfaceVersion
-unsetenv
-xf86AllocateInput
-stderr
-xf86Msg
-xf86CloseSerial
-xf86InitValuatorDefaults
-realloc
-getpwuid_r
-cos
-xf86WriteSerial
-fprintf
-xf86OptionListFree
-write
-xf86AddModuleInfo
-XNFrealloc
-xf86BlockSIGIO
-XisbBlockDuration
-fcntl
-screenInfo
-iconv_close
-rename
-xf86SetSerialSpeed
-fflush
-abs
-lseek
-stat
-__deregister_frame_info_bases
-nl_langinfo
-__register_frame_info_bases
-open
-___errno
-fstat
-ftruncate
-strpbrk
-__iob
-__moddi3
-__umoddi3
-__udivdi3
-__divdi3
-flock
-sigdelset
-sigfillset
-pthread_sigmask
-mprotect
-mmap64
-memalign
-posix_memalign
-munmap